/* z_io.h (parallel io)

   Ambros Marzetta

 * $Source: /home/schilte/marzetta/work/distr/zram/RCS/z_io.h,v $
 * $Revision: 1.2 $
 * $Date: 1996/05/15 16:54:49 $
 * $Log: z_io.h,v $
 * Revision 1.2  1996/05/15  16:54:49  marzetta
 * \Exported z_io_AppendProc
 *
 * Revision 1.1  1996/05/08  20:29:30  marzetta
 * Initial revision
 *
 */

#ifndef _Z_IO_H_
#define _Z_IO_H_

#include <stdio.h>
#include "z_base.h"

#ifndef _GETOPT_H_
#define _GETOPT_H_

extern int getopt(int, char * const [], const char *);
extern char *optarg;
extern int optind;
extern int optopt;
extern int opterr;

#endif /* _GETOPT_H_ */

#ifndef PATH_MAX
#define PATH_MAX 255
#endif


/* Open / Close -------------------------------------------------------- */

void z_io_RedirectStdout(const char *path);
/* (FE only) Redirect stdout to a file (different for each processor) */

int z_io_MakeBackup(const char *path);
/* Rename the file path.nnn to path.nnn.bak where nnn is the processor
   number. */

FILE *z_fopen(const char *path, const char *mode);
/* Open the file named by the path parameter with a processor number dependent
   extension. */

void z_io_AppendProc(char *s, const char *path, int numprocs, int myproc);
/* Append the processor number to the path (s := path.nnn). */


/* Read / Write -------------------------------------------------------- */

long z_fread(void *pointer, long size, long num_items, FILE *stream);
/* Same as fread() but aborts on error and eof */

void z_WriteNode(FILE *f, z_NodeP node);
/* Write the node to the file. node may be NULL. */

z_NodeP z_ReadNode(FILE *f);


/* Initialization ------------------------------------------------------ */

void z_io_Init(void);

#endif /* _Z_IO_H_ */
